% MultiPlot }`(}^C)vbgNX
% 2024/04/03 Yokokura, Yuki
%
% {vbg̓
% E]Sɐ䉺ɒu鑽ivbg
% @(ftHsubplotł͗]肷Ę_p̐}ɂ)
% EtHgETCYA̐FEAȂǁA܂؂ݒȂėǂ
%
% @ TCY`p[^̈ʒu֌Ẃ̒ʂ
%{
    0%                                                  100%
100% +--------------------- FigWidth ----------------------+
     |       |TopMargin
     |       +        +--------------------------+
     |       |        |       PlaneNum = 2       |
     |       |        |PlaneHeight               |
     |       |        |                          |
     |       |        +--------------------------+
     |       |        +--------------------------+ <- XaxisSubMargin
     |Fig    |All     |       PlaneNum = 1       |
     |Height |Planes  |PlaneHeight               |
     |       |Height  |                          |
     |       |        +--------------------------+
     |       |        +--------------------------+ <- XaxisSubMargin
     |       |        |       PlaneNum = 0       |
     |       |        |PlaneHeight               |
     |       |        |                          |
     |       +        +------- PlaneWidth -------+
     |       |Xaxis
     |       |Margin
  0% +----------------+                          +---------+
        YaxisMargin                              RightMargin
%}
classdef MultiPlot < handle

% 萔vpeB
properties(Constant)

end

% NXvpeB
properties(SetAccess = protected)
	FigHandle;				% figurenh
	FigLeft    = 0;			% [px] figure̍W
	FigBottom  = 0;			% [px] figurẻW
	FigWidth   = 0;			% [px] figure̕
	FigHeight  = 0;			% [px] figure̍
	NumPlanes  = 0;			% vbgʂ̒i
	CurrPlane  = 0;			% ݑI𒆂̃vbg
	PlaneHandle;			% axesnh
	PlaneLeft  = 0;			% [px] vbgʂ̍ʒu
	PlaneWidth = 0;			% [px] vbgʂ̉
	PlaneHeight = 0;		% [px] vbgʂ̍
	AllPlanesHeight = 0;	% [px] ׂẴvbgʂ̍
	YaxisMargin = 130;		% [px] Yp̗]
	XaxisSubMargin = 3;		% [px] ԒiXp̗]
	XaxisMargin = 70;		% [px] ŉiXp̗]
	TopMargin   = 10;		% [px] 㑤̗]
	RightMargin = 20;		% [px] E̗]
	FontSize   = 18;		% [pt] TCY
	FontName   = 'Times New Roman';	% tHg
	AxisColor  = [0, 0, 0];			% ̐F
	BackColor  = [1, 1, 1];			% wiF
	ColorBlack = [      0,       0,       0];	% vbg̐F(n)
	ColorGray  = [127/255, 127/255, 127/255];	% vbg̐F(Dn)
	ColorRed   = [225/255,   0/255,   0/255];	% vbg̐F(Ԍn)
	ColorGreen = [  0/255, 255/255, 127/255];	% vbg̐F(Όn)
	ColorBlue  = [  0/255, 127/255, 255/255];	% vbg̐F(n)
	WidthNarrow = 1.2;		% vbg̑()
	WidthNormal = 2.0;		% vbg̑()
	WidthWide   = 2.8;		% vbg̑()
	LineColors;				% vbg̐FpAzz
	LineWidths;				% vbg̑pAzz
	LegendEdgeColor = [1, 1, 1];			% }̘gF
	LegendBackColor = [0.95, 0.95, 0.95];	% }̔wiF
	XaxisName = 'Time [s]';	% Ԏ̃x
	Xmin = 0;				% X͈͂̍ŏl
	Xstp = 0;				% X̃ObhԊu
	Xmax = 0;				% X͈͂̍ől
end

% ÓI\bh
methods(Static)
	% CSVt@Cǂݍފ֐
	function varargout = LoadCsvFile(FileName)
		% CSVt@Cǂݍ
		FileFormat = FileName(length(FileName)-3:length(FileName));	% gqǂݍ
		if strcmp(FileFormat, '.csv')
			RawData = readmatrix(FileName,'FileType','text');		% CSVt@C̏ꍇ
		else
			assert(false, 'MultiPlot: m̃t@C`');			% m̃t@C̏ꍇ
		end
		
		% o͕ϐ̐̃`FbN
		[h, w] = size(RawData);
		if w < nargout
			assert(false, 'MultiPlot: CSVt@C̗̐ < o͕ϐ̐');
		end
		
		% o͕ϐƂĕԂ
		for i = 1:nargout
			varargout{i} = RawData(:, i);
		end
	end
end

% \bh
methods
	
	% RXgN^
	function this = MultiPlot(Handle)
		this.FigHandle = Handle;
		clf(this.FigHandle);
		set(this.FigHandle, 'PaperPositionMode','auto');
		set(this.FigHandle, 'Position',[this.FigLeft, this.FigBottom, this.FigWidth, this.FigHeight]);
		set(this.FigHandle, 'Color',this.BackColor);
		
		% vbgF̏
		ColorDefs = {this.ColorBlack, this.ColorGray, this.ColorRed, this.ColorGreen, this.ColorBlue};
		ColorNames = ["Black", "Gray", "Red", "Green", "Blue"];
		this.LineColors = dictionary(ColorNames, ColorDefs);	% Azz(R2022bȍ~Kv)
		
		% vbg̏
		WidthDefs = {this.WidthNarrow, this.WidthNormal, this.WidthWide};
		WidthSizes = ["Thin", "Normal", "Heavy"];
		this.LineWidths = dictionary(WidthSizes, WidthDefs);	% Azz(R2022bȍ~Kv)
	end
	
	% Otʒu̐ݒ֐
	function FigurePosition(this, Left, Bottom)
		this.FigLeft = Left;
		this.FigBottom = Bottom;
		set(this.FigHandle, 'Position', [this.FigLeft, this.FigBottom, this.FigWidth, this.FigHeight]);
	end
	
	% OtTCY̐ݒ֐
	function FigureSize(this, Width, Height)
		this.FigWidth = Width;
		this.FigHeight = Height;
		set(this.FigHandle, 'Position', [this.FigLeft, this.FigBottom, this.FigWidth, this.FigHeight]);
	end
	
	% ]̐ݒ֐
	function FigureMargin(this, Left, Bottom, Right)
		this.YaxisMargin = Left;	% [px] Yp̗]
		this.XaxisMargin = Bottom;	% [px] ŉiXp̗]
		this.RightMargin = Right;	% [px] E̗]
	end
	
	% tHg̐ݒ֐
	function Font(this, Name, Size)
		this.FontName = Name;
		this.FontSize = Size;
	end
	
	% vbgʂ̒i̐ݒ֐
	function NumOfPlanes(this, NumPlanes)
		% TCY`p[^̌vZ
		this.NumPlanes = NumPlanes;
		this.AllPlanesHeight = this.FigHeight - this.XaxisMargin - this.TopMargin + this.XaxisSubMargin;% [px] ׂẴvbgʂ̍
		this.PlaneHeight = this.AllPlanesHeight/this.NumPlanes - this.XaxisSubMargin;					% [px] vbgʂ̍
		this.PlaneWidth = this.FigWidth - this.YaxisMargin - this.RightMargin;							% [px] vbgʂ̕
		this.PlaneLeft = this.YaxisMargin;																% [px] vbgʂ̍ʒu
		
		% ĩvbgʂ𐶐
		for i = 0:1:(NumPlanes - 1)
			this.PlaneHandle(i + 1) = this.GeneratePlane(i);
		end
	end
	
	function FontSettings(this, Ax)
		% XxƃtHg̐ݒ
		if this.CurrPlane ~= 0
			set(Ax,'XTickLabel',{});	% ŉiȊOXx
		else
			xlabel(this.XaxisName,'FontSize',this.FontSize,'FontName',this.FontName);	% ŉîXxt
		end
		
		% tHgƐF̐ݒ
		set(Ax, 'FontSize',this.FontSize, 'FontName',this.FontName);
		set(Ax, 'Color',this.BackColor, 'XColor',this.AxisColor, 'YColor',this.AxisColor);
	end
	
	% vbgʂ𐶐֐
	function Ax = GeneratePlane(this, PlaneNum)
		% WvZ
		w = 1/this.FigWidth*this.PlaneWidth;	% vbgʂ̕Z [px]  [%]
		h = 1/this.FigHeight*this.PlaneHeight;	% vbgʂ̍Z [px]  [%]
		l = 1/this.FigWidth*this.PlaneLeft;		% vbgʂ̍ʒuZ [px]  [%]
		b = 1/this.FigHeight*(this.AllPlanesHeight/this.NumPlanes*PlaneNum + this.XaxisMargin);		% vbgʂ̉ʒuZ [px]  [%]
		Pos = [l, b, w, h];						% [%, %, %, %] 
		Ax = axes('Position', Pos);				% vbgʐ
		plot(Ax, 0, 0);							% pplot() vbgĂ
		
		% XxƃtHg̐ݒ
		if PlaneNum ~= 0
			set(Ax,'XTickLabel',{});	% ŉiȊOXx
		else
			xlabel(this.XaxisName,'FontSize',this.FontSize,'FontName',this.FontName);	% ŉîXxt
		end
		
		% tHgƐF̐ݒ
		ylabel(Ax, 'y', 'FontSize',this.FontSize, 'FontName',this.FontName);
		set(Ax, 'FontSize',this.FontSize, 'FontName',this.FontName);
		set(Ax, 'Color',this.BackColor, 'XColor',this.AxisColor, 'YColor',this.AxisColor);
	end
	
	% vbgʂI֐(iڂɃvbg邩̐ݒ)
	function SelectPlane(this, PlaneNum)
		this.CurrPlane = this.NumPlanes - PlaneNum;
		axes(this.PlaneHandle( this.NumPlanes - PlaneNum + 1 ))
	end
	
	% X͈͂̐ݒ֐
	function XaxisRange(this, Xmin, Xstp, Xmax)
		this.Xmin = Xmin;
		this.Xstp = Xstp;
		this.Xmax = Xmax;
		
		% ĩvbgʂɑ΂X͈͂ݒ
		for i = 1:1:this.NumPlanes
			xlim(this.PlaneHandle(i), [Xmin, Xmax]);
			set(this.PlaneHandle(i),'XTickMode','manual','XTick', Xmin:Xstp:Xmax);
		end
	end
	
	% Xx̐ݒ֐
	function XaxisLabel(this, Xname)
		this.XaxisName = Xname;
		xlabel(this.PlaneHandle(1), this.XaxisName,'FontSize',this.FontSize,'FontName',this.FontName);	% ŉiXx
	end
	
	% X/YObhݒ肷֐
	function AutoGrid(this, Ax)
		Ymax = max(Ax.YTick);
		Ymin = min(Ax.YTick);
		Ystp = (Ymax - Ymin)/(length(Ax.YTick) - 1);
		Xmax = max(Ax.XTick);
		Xmin = min(Ax.XTick);
		Xstp = (Xmax - Xmin)/(length(Ax.XTick) - 1);
		grid on;
		axis([Xmin, Xmax, Ymin - Ystp/2, Ymax + Ystp/2]);
		set(Ax,'XTickMode','manual','YTickMode','manual','XTick', Xmin:Xstp:Xmax,'YTick', Ymin:Ystp:Ymax);
		Ax.YAxis.Exponent = 0;
	end
	
	% YObh蓮ݒ肷֐
	function ManualGrid(this, Ymin, Ystp, Ymax)
		grid on;
		ylim([Ymin - Ystp/2, Ymax + Ystp/2]);
		set(gca,'YTickMode','manual','YTick', Ymin:Ystp:Ymax);
	end
	
	% cx̐ݒ֐
	function Label(this, Name)
		ylabel(gca, Name, 'FontSize',this.FontSize, 'FontName',this.FontName);
	end
	
	% }̐ݒ֐
	function Legend(this, Name, Position, Direction)
		nll = {char};		% 󕶎
		Name = [nll, Name];	% pplot()̖̕}͔\
		h = legend(Name, 'Location',Position, 'Orientation',Direction);
		set(h, 'TextColor',this.AxisColor);
		set(h, 'FontSize',this.FontSize, 'FontName',this.FontName);
		set(h, 'EdgeColor', this.LegendEdgeColor, 'Color', this.LegendBackColor);
	end
	
	% f[^_ETvOĊԈ֐
	function xout = DownSampling(this, xin, dsmpl)
		len = length(xin(:,1));
		xout = xin(1:dsmpl:len, :);
	end
	
	% vbg֐
	function Plot(this, varargin)
		% ǂݍ
		PlotFunc = varargin{1};	% ֐nh
		Argin = varargin{2};	% Zz
		x = Argin{1};			% Xf[^
		y = Argin{2};			% Yf[^
		Color = Argin{3};		% ̐F
		Width = Argin{4};		% ̑
		if size(varargin) == [1, 3]
			% vbg_̎ނw肳ꂽꍇ
			PlotType = varargin{3};
		else
			% vbg_̎ނw肳Ȃꍇ
			PlotType = ' ';
		end
		
		% ̐œύX
		if length(Argin) == 4
			% _ETvOȂꍇ
			DownSmplRate = 1;
		else
			% _ETvOꍇ
			DownSmplRate = Argin{5};
			x = this.DownSampling(x, DownSmplRate);
			y = this.DownSampling(y, DownSmplRate);
		end
		
		% ۂ̃vbg
		hold on;
		h = PlotFunc(gca, x, y, PlotType);
		c = this.LineColors(Color);
		w = this.LineWidths(Width);
		set(h, 'LineWidth', w{1}, 'Color', c{1});
		hold off;
		this.AutoGrid(gca);
	end
	
	% Kivbg֐
	function StairsPlot(this, varargin)
		this.Plot(@stairs, varargin);
	end
	
	% `vbg֐
	function LinePlot(this, varargin)
		this.Plot(@plot, varargin);
	end
	
	% _vbg֐
	function DotPlot(this, varargin)
		this.Plot(@plot, varargin, '.');
	end
	
	% ~vbg֐
	function CrossPlot(this, varargin)
		this.Plot(@plot, varargin, 'x');
	end
	
	% vbg֐
	function CirclePlot(this, varargin)
		this.Plot(@plot, varargin, 'o');
	end
	
	% {vbg֐
	function PlusPlot(this, varargin)
		this.Plot(@plot, varargin, '+');
	end
	
	% PNG摜EPSt@C
	function SavePNGandEPS(this, FileName)
		PngFileName = strcat(FileName(1:length(FileName)-4), '.png');	% gqPNGɕϊ
		EpsFileName = strcat(FileName(1:length(FileName)-4), '.eps');	% gqEPSɕϊ
		exportgraphics(this.FigHandle, PngFileName,'ContentType','image', 'Resolution',150);
		exportgraphics(this.FigHandle, EpsFileName,'ContentType','vector','BackgroundColor','none');
	end
	
	% PNG摜PDFt@C
	function SavePNGandPDF(this, FileName)
		PngFileName = strcat(FileName(1:length(FileName)-4), '.png');	% gqPNGɕϊ
		PdfFileName = strcat(FileName(1:length(FileName)-4), '.pdf');	% gqPDFɕϊ
		exportgraphics(this.FigHandle, PngFileName,'ContentType','image', 'Resolution',150);
		exportgraphics(this.FigHandle, PdfFileName,'ContentType','vector');
	end
end
end

